Index: cpp/gdk/loadertest.cpp
===================================================================
--- cpp/gdk/loadertest.cpp	(revision 45)
+++ cpp/gdk/loadertest.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "genotypeloader.h"
Index: cpp/gdk/model.cpp
===================================================================
--- cpp/gdk/model.cpp	(revision 45)
+++ cpp/gdk/model.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "nonstd.h"
@@ -960,9 +960,18 @@
 			}
 			}
-		if (final) if (j->d()>getMaxJoint().d.x)
+		if (final)
+			{
+			if (j->d()>getMaxJoint().d.x)
 			{
 			ret=0;
 			FMprintf("Model","internalCheck",FMLV_ERROR,"delta too big in joint #%d (%s)",
 				 i,(const char*)geno.getName());
+			}
+			else if (j->d()<getMinJoint().d.x)
+			{
+			ret=0;
+			FMprintf("Model","internalCheck",FMLV_ERROR,"delta too small in joint #%d (%s)",
+				 i,(const char*)geno.getName());
+			}
 			}
 		}
@@ -1259,11 +1268,11 @@
 class MaxNeuro: public Neuro {public: MaxNeuro() {Param par(f0_neuro_paramtab,this);par.setMax();}};
 
-const Part& Model::getMinPart() {static MinPart part; return part;}
-const Part& Model::getMaxPart() {static MaxPart part; return part;}
-const Part& Model::getDefPart() {static Part part; return part;}
-const Joint& Model::getMinJoint() {static MinJoint joint; return joint;}
-const Joint& Model::getMaxJoint() {static MaxJoint joint; return joint;}
-const Joint& Model::getDefJoint() {static Joint joint; return joint;}
-const Neuro& Model::getMinNeuro() {static MinNeuro neuro; return neuro;}
-const Neuro& Model::getMaxNeuro() {static MaxNeuro neuro; return neuro;}
-const Neuro& Model::getDefNeuro() {static Neuro neuro; return neuro;}
+Part& Model::getMinPart() {static MinPart part; return part;}
+Part& Model::getMaxPart() {static MaxPart part; return part;}
+Part& Model::getDefPart() {static Part part; return part;}
+Joint& Model::getMinJoint() {static MinJoint joint; return joint;}
+Joint& Model::getMaxJoint() {static MaxJoint joint; return joint;}
+Joint& Model::getDefJoint() {static Joint joint; return joint;}
+Neuro& Model::getMinNeuro() {static MinNeuro neuro; return neuro;}
+Neuro& Model::getMaxNeuro() {static MaxNeuro neuro; return neuro;}
+Neuro& Model::getDefNeuro() {static Neuro neuro; return neuro;}
Index: cpp/gdk/model.def
===================================================================
--- cpp/gdk/model.def	(revision 45)
+++ cpp/gdk/model.def	(revision 64)
@@ -93,4 +93,5 @@
 
 
+prop:id=r,name="Range",type="f 0.0 1.0 1.0"
 
 
@@ -129,9 +130,28 @@
 
 
+neuro: id=VEye,name="Vector Eye [EXPERIMENTAL!]",info="",inputs=1,output=1,location=1  ,symbol="11,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,14,70,50,65,40,60,35,45,30,30,30,15,35,10,40,5,50,10,60,15,65,30,70,45,70,60,65,65,60,70,50,8,38,67,28,62,23,52,28,42,38,37,48,42,53,52,48,62,38,67,4,33,52,38,47,43,52,38,57,33,52,5,70,50,60,40,45,35,30,35,15,40,5,50,1,53,33,58,22,1,62,36,68,26,1,45,30,47,19,1,35,30,35,19,1,27,31,24,20,1,18,34,12,24" 
+
+prop:id=tx,name="target.x",type="f   "
+prop:id=ty,name="target.y",type="f   "
+prop:id=tz,name="target.z",type="f   "
+prop:id=ts,name="target shape",type="s 0 -1 0"
+prop:id=p,name="perspective",type="f 0.1 10.0 1.0"
+prop:id=s,name="scale",type="f 0.1 100.0 1.0"
+prop:id=h,name="show hidden lines",type="d 0 1 0"
+prop:id=o,name="output lines count (each line needs four channels)",type="d 0 99 0"
+prop:id=d,name="debug",type="d 0 1 0"
+
+
+neuro: id=VMotor,name="Visual-Motor Cortex [EXPERIMENTAL!]",info="Must be connected to the VEye and properly set up.",inputs=-1,output=1,location=0 
+prop:id=noIF,name="number of basic features",type="d   "
+prop:id=noDim,name="number of degrees of freedom",type="d   "
+prop:id=params,name="parameters",type="s   "
+ 
+
 neuro: id=Sti,name="Sticky [EXPERIMENTAL!]",info="",inputs=1,output=0,location=1  ,vhints=32 
 
 
 
-neuro: id=LMu,name="Linear muscle [EXPERIMENTAL!]",info="",inputs=1,output=0,location=2  ,vhints=16 
+neuro: id=LMu,name="Length muscle [EXPERIMENTAL!]",info="",inputs=1,output=0,location=2  ,vhints=16 
 
 prop:id=p,name="power",type="f 0.01 1.0 1.0"
Index: cpp/gdk/model.h
===================================================================
--- cpp/gdk/model.h	(revision 45)
+++ cpp/gdk/model.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _MODEL_H_
@@ -408,13 +408,13 @@
 ///////////////////////////
 
-static const Part& getMinPart();
-static const Part& getMaxPart();
-static const Part& getDefPart();
-static const Joint& getMinJoint();
-static const Joint& getMaxJoint();
-static const Joint& getDefJoint();
-static const Neuro& getMinNeuro();
-static const Neuro& getMaxNeuro();
-static const Neuro& getDefNeuro();
+static Part& getMinPart();
+static Part& getMaxPart();
+static Part& getDefPart();
+static Joint& getMinJoint();
+static Joint& getMaxJoint();
+static Joint& getDefJoint();
+static Neuro& getMinNeuro();
+static Neuro& getMaxNeuro();
+static Neuro& getDefNeuro();
 };
 
Index: cpp/gdk/modelparts.cpp
===================================================================
--- cpp/gdk/modelparts.cpp	(revision 45)
+++ cpp/gdk/modelparts.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include <stdlib.h>
@@ -21,4 +21,6 @@
 #include "multirange.h"
 #include "extvalue.h"
+
+#include "neuroclsobject.h"
 
 template<>
@@ -524,4 +526,9 @@
 }
 
+void Neuro::get_classObject(PARAMGETARGS)
+{
+NeuroClassExt::makeStaticObject(ret,getClass());
+}
+
 /////// old items
 #ifdef MODEL_V1_COMPATIBLE
Index: cpp/gdk/modelparts.h
===================================================================
--- cpp/gdk/modelparts.h	(revision 45)
+++ cpp/gdk/modelparts.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _MODELPARTS_H_
@@ -241,10 +241,10 @@
 	/** draw the neuron at the second part when attached to joint (default is in the middle) */
    AtSecondPart=8,
-	/** use muscle colour for this neuro unit */
-   MuscleClass=16,
+	/** use effector colour for this neuro unit */
+   EffectorClass=16,
 	/** use receptor colour for this neuro unit */
    ReceptorClass=32,
    V1BendMuscle=64,
-   V1RotMuscle=128
+   V1RotMuscle=128,
  };
 
@@ -349,4 +349,5 @@
 PARAMPROCDEF(p_getInputNeuroIndex);
 PARAMPROCDEF(p_getInputWeight);
+PARAMGETDEF(classObject);
 #undef STATRICKCLASS
 
Index: cpp/gdk/multimap.cpp
===================================================================
--- cpp/gdk/multimap.cpp	(revision 45)
+++ cpp/gdk/multimap.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "multimap.h"
Index: cpp/gdk/multimap.h
===================================================================
--- cpp/gdk/multimap.h	(revision 45)
+++ cpp/gdk/multimap.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _MULTIMAP_H_
Index: cpp/gdk/multiparamload.cpp
===================================================================
--- cpp/gdk/multiparamload.cpp	(revision 45)
+++ cpp/gdk/multiparamload.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "multiparamload.h"
@@ -105,5 +105,5 @@
 		{
 		lastclass->load(file);
-		if (maybeBreak(AfterObject))
+		if ((status!=Finished) && maybeBreak(AfterObject))
 			break;
 		continue;
@@ -144,5 +144,5 @@
 			continue;
 			}
-		else if (maybeBreak(OnComment))
+		else if ((status!=Finished) && maybeBreak(OnComment))
 			{
 			lastcomment=t+1;
Index: cpp/gdk/multiparamload.h
===================================================================
--- cpp/gdk/multiparamload.h	(revision 45)
+++ cpp/gdk/multiparamload.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _MULTIPARAMLOAD_H_
Index: cpp/gdk/multirange.cpp
===================================================================
--- cpp/gdk/multirange.cpp	(revision 45)
+++ cpp/gdk/multirange.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "multirange.h"
Index: cpp/gdk/multirange.h
===================================================================
--- cpp/gdk/multirange.h	(revision 45)
+++ cpp/gdk/multirange.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _MULTIRANGE_H_
Index: cpp/gdk/neuroclasses.h
===================================================================
--- cpp/gdk/neuroclasses.h	(revision 45)
+++ cpp/gdk/neuroclasses.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 CLASS(StdNeuron,"N","Neuron",`"Standard Framsticks Neuron, compatible with 1.0"',-1,1,0,0,0)
Index: cpp/gdk/neurocls-library.m4
===================================================================
--- cpp/gdk/neurocls-library.m4	(revision 45)
+++ cpp/gdk/neurocls-library.m4	(revision 64)
@@ -15,5 +15,5 @@
 define(`AtSecondPart',`8')
 define(`InTheMiddle',`12')
-define(`MuscleClass',`16')
+define(`EffectorClass',`16')
 define(`ReceptorClass',`32')
 define(`V1BendMuscle',`64')
Index: cpp/gdk/neurofactory.cpp
===================================================================
--- cpp/gdk/neurofactory.cpp	(revision 45)
+++ cpp/gdk/neurofactory.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "neurofactory.h"
@@ -17,5 +17,7 @@
 NeuroImpl* ni=(NeuroImpl*)nc->impl;
 if (!ni) return 0;
-return ni->makeNew();
+ni=ni->makeNew();
+if (ni) ni->neuroclass=nc;
+return ni;
 }
 
Index: cpp/gdk/neurofactory.h
===================================================================
--- cpp/gdk/neurofactory.h	(revision 45)
+++ cpp/gdk/neurofactory.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _NEUROFACTORY_H_
Index: cpp/gdk/neuroimpl-body-gdk.h
===================================================================
--- cpp/gdk/neuroimpl-body-gdk.h	(revision 45)
+++ cpp/gdk/neuroimpl-body-gdk.h	(revision 64)
@@ -1,9 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
-
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _NEUROIMPLBODY_H_
Index: cpp/gdk/neuroimpl-channels.cpp
===================================================================
--- cpp/gdk/neuroimpl-channels.cpp	(revision 45)
+++ cpp/gdk/neuroimpl-channels.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "neuroimpl-channels.h"
Index: cpp/gdk/neuroimpl-channels.h
===================================================================
--- cpp/gdk/neuroimpl-channels.h	(revision 45)
+++ cpp/gdk/neuroimpl-channels.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _NEUROIMPLCHANNELS_H
Index: cpp/gdk/neuroimpl-fuzzy-f0.cpp
===================================================================
--- cpp/gdk/neuroimpl-fuzzy-f0.cpp	(revision 45)
+++ cpp/gdk/neuroimpl-fuzzy-f0.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 /// this is a module included into neuroimpl-fuzzy
Index: cpp/gdk/neuroimpl-fuzzy-f0.h
===================================================================
--- cpp/gdk/neuroimpl-fuzzy-f0.h	(revision 45)
+++ cpp/gdk/neuroimpl-fuzzy-f0.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 /// this is a modul included into neuroimpl-fuzzy
Index: cpp/gdk/neuroimpl-fuzzy.cpp
===================================================================
--- cpp/gdk/neuroimpl-fuzzy.cpp	(revision 45)
+++ cpp/gdk/neuroimpl-fuzzy.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "neuroimpl-fuzzy.h"
Index: cpp/gdk/neuroimpl-fuzzy.h
===================================================================
--- cpp/gdk/neuroimpl-fuzzy.h	(revision 45)
+++ cpp/gdk/neuroimpl-fuzzy.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _NEUROIMPLFUZZY_H_
Index: cpp/gdk/neuroimpl-simple.cpp
===================================================================
--- cpp/gdk/neuroimpl-simple.cpp	(revision 45)
+++ cpp/gdk/neuroimpl-simple.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "neuroimpl-simple.h"
Index: cpp/gdk/neuroimpl-simple.h
===================================================================
--- cpp/gdk/neuroimpl-simple.h	(revision 45)
+++ cpp/gdk/neuroimpl-simple.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _NEUROIMPLSIMPLE_H_
Index: cpp/gdk/neuroimpl.cpp
===================================================================
--- cpp/gdk/neuroimpl.cpp	(revision 45)
+++ cpp/gdk/neuroimpl.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "neuroimpl.h"
@@ -23,5 +23,5 @@
 {
 {"Creature: Neurons",1,2,"nnsim",},
-{"randinit",1,0,"Random initialization","f 0 10 0.01",FIELD(randominit),"Initialize all neuron states with uniform distribution random numbers"},
+{"randinit",1,0,"Random initialization","f 0 10 0.01",FIELD(randominit),"Allowed range for initializing all neuron states with uniform distribution random numbers and zero mean. Set 0 for deterministic initialization."},
 {"touchrange",1,0,"T receptor range","f 0 100 1",FIELD(touchrange),},
 {0,0,0,},
@@ -277,40 +277,40 @@
 ParamEntry neuroimpl_tab[]=
 {
-{"Neuro",1,26+NEUROIMPL_SIGNAL_PROPS,"Neuro","Live Neuron object."},
-
-{"getInputState",0,0,"get input signal","p f(d input)",PROCEDURE(p_get),},
-{"getInputWeight",0,0,"get input weight","p f(d input)",PROCEDURE(p_getweight),},
-{"getWeightedInputState",0,0,"get weighted input signal","p f(d input)",PROCEDURE(p_getw),},
-{"getInputSum",0,0,"get signal sum","p f(d input)",PROCEDURE(p_getsum),},
-{"getWeightedInputSum",0,0,"get weighted signal sum","p f(d input)",PROCEDURE(p_getwsum),"uses any number of inputs starting with the specified input. getWeightedInputSum(0)=weightedInputSum"},
-{"getInputCount",0,0,"get input count","d",GETONLY(count),},
-{"inputSum",0,0,"full signal sum","f",GETONLY(sum),},
-{"weightedInputSum",0,0,"full weighted signal sum","f",GETONLY(wsum),},
-{"getInputChannelCount",0,0,"get channel count for input","p d(d input)",PROCEDURE(p_getchancount),},
-{"getInputStateChannel",0,0,"get input signal from channel","p f(d input,d channel)",PROCEDURE(p_getchan),},
-{"getWeightedInputStateChannel",0,0,"get weighted input signal from channel","p f(d input,d channel)",PROCEDURE(p_getwchan),},
-{"state",0,0,"neuron state (channel 0)","f",GETSET(state),"when read, returns the current neuron state.\nWhen written, sets the next neuron state (for use in the neuron definition)"},
-{"channelCount",0,0,"number of output channels","d",GETSET(channels),},
-{"getStateChannel",0,0,"get output state for channel","p f(d channel)",PROCEDURE(p_getstate),},
-{"setStateChannel",0,0,"set output state for channel","p(d channel,f value)",PROCEDURE(p_setstate),},
-{"hold",0,0,"Hold state","d 0 1",GETSET(hold),"",},
-{"currState",0,0,"neuron state (channel 0)","f",GETSET(cstate),"the only difference from the \"state\" field is that currState, when written, changes the internal neuron state immediately (which disturbs the regular synchronous NN operation). This feature should only be used while controlling the neuron 'from outside' (like a neuro probe) and not in the neuron definition.",},
-{"setCurrStateChannel",0,0,"set neuron for channel","p(d channel,f value)",PROCEDURE(p_setcstate),"like \"currState\""},
-{"position_x",0,0,"position x","f",GETONLY(position_x),},
-{"position_y",0,0,"position y","f",GETONLY(position_y),},
-{"position_z",0,0,"position z","f",GETONLY(position_z),},
-{"creature",0,0,"get owner creature","o Creature",GETONLY(creature),},
-{"part",0,0,"the Part object where this neuron is located","o MechPart",GETONLY(part),},
-{"joint",0,0,"the Joint object where this neuron is located","o MechJoint",GETONLY(joint),},
-{"fields",0,0,"custom neuron fields","o Fields",GETONLY(fields),
+{"Neuro",1,27+NEUROIMPL_SIGNAL_PROPS,"Neuro","Live Neuron object."},
+
+{"getInputState",0,0,"Get input signal","p f(d input)",PROCEDURE(p_get),},
+{"getInputWeight",0,0,"Get input weight","p f(d input)",PROCEDURE(p_getweight),},
+{"getWeightedInputState",0,0,"Get weighted input signal","p f(d input)",PROCEDURE(p_getw),},
+{"getInputSum",0,0,"Get signal sum","p f(d input)",PROCEDURE(p_getsum),},
+{"getWeightedInputSum",0,0,"Get weighted signal sum","p f(d input)",PROCEDURE(p_getwsum),"Uses any number of inputs starting with the specified input. getWeightedInputSum(0)=weightedInputSum"},
+{"getInputCount",0,0,"Get input count","d",GETONLY(count),},
+{"inputSum",0,0,"Full signal sum","f",GETONLY(sum),},
+{"weightedInputSum",0,0,"Full weighted signal sum","f",GETONLY(wsum),},
+{"getInputChannelCount",0,0,"Get channel count for input","p d(d input)",PROCEDURE(p_getchancount),},
+{"getInputStateChannel",0,0,"Get input signal from channel","p f(d input,d channel)",PROCEDURE(p_getchan),},
+{"getWeightedInputStateChannel",0,0,"Get weighted input signal from channel","p f(d input,d channel)",PROCEDURE(p_getwchan),},
+{"state",0,0,"Neuron state (channel 0)","f",GETSET(state),"When read, returns the current neuron state.\nWhen written, sets the next neuron state (for use in the neuron definition)"},
+{"channelCount",0,0,"Number of output channels","d",GETSET(channels),},
+{"getStateChannel",0,0,"Get output state for channel","p f(d channel)",PROCEDURE(p_getstate),},
+{"setStateChannel",0,0,"Set output state for channel","p(d channel,f value)",PROCEDURE(p_setstate),},
+{"hold",0,0,"Hold state","d 0 1",GETSET(hold),"\"Holding\" means keeping the neuron state as is, blocking the regular neuron operation. This is useful when your script needs to inject some control signals into the NN. Without \"holding\", live neurons would be constantly overwriting your changes, and the rest of the NN could see inconsistent states, depending on the connections. Setting hold=1 ensures the neuron state will be only set by you, and not by the neuron. The enforced signal value can be set using Neuro.currState before or after setting hold=1. Set hold=0 to resume normal operation.",},
+{"currState",0,0,"Neuron state (channel 0)","f",GETSET(cstate),"The only difference from the \"state\" field is that currState, when written, changes the internal neuron state immediately (which disturbs the regular synchronous NN operation). This feature should only be used while controlling the neuron 'from outside' (like a neuro probe) and not in the neuron definition. See also: Neuro.hold",},
+{"setCurrStateChannel",0,0,"Set neuron for channel","p(d channel,f value)",PROCEDURE(p_setcstate),"Analogous to \"currState\"."},
+{"position_x",0,0,"Position x","f",GETONLY(position_x),},
+{"position_y",0,0,"Position y","f",GETONLY(position_y),},
+{"position_z",0,0,"Position z","f",GETONLY(position_z),},
+{"creature",0,0,"Gets owner creature","o Creature",GETONLY(creature),},
+{"part",0,0,"The Part object where this neuron is located","o MechPart",GETONLY(part),},
+{"joint",0,0,"The Joint object where this neuron is located","o MechJoint",GETONLY(joint),},
+{"fields",0,0,"Custom neuron fields","o Fields",GETONLY(fields),
 "Neurons can have different fields depending on their class. Script neurons have their fields defined using the \"prop:\" syntax. If you develop a custom neuron script you should use the Fields object for accessing your own neuron fields. The Neuro.fields property is meant for accessing the neuron fields from the outside script.\n"
 "Examples:\n"
-"var c=LiveLibrary.createFromString(\"X[N]\");\n"
+"var c=Populations.createFromString(\"X[N]\");\n"
 "Simulator.print(\"standard neuron inertia=\"+c.getNeuro(0).fields.in);\n"
-"c=LiveLibrary.createFromString(\"X[Nn,e:0.1]\");\n"
+"c=Populations.createFromString(\"X[Nn,e:0.1]\");\n"
 "Simulator.print(\"noisy neuron error rate=\"+c.getNeuro(0).fields.e);\n"
 "\n"
 "The Interface object can be used to discover which fields are available for a certain neuron object:\n"
-"c=LiveLibrary.createFromString(\"X[N]\");\n"
+"c=Populations.createFromString(\"X[N]\");\n"
 "var iobj=Interface.makeFrom(c.getNeuro(0).fields);\n"
 "var i;\n"
@@ -318,4 +318,5 @@
 " Simulator.print(iobj.getId(i)+\" (\"+iobj.getName(i)+\")\");",},
 {"def",0,0,"Neuron definition from which this live neuron was built","o NeuroDef",GETONLY(neurodef),},
+{"classObject",0,0,"Neuron class for this neuron","o NeuroClass",GETONLY(classObject),},
 #ifdef NEURO_SIGNALS
 {"signals",0,PARAM_READONLY,"Signals","o NeuroSignals",FIELD(sigs_obj),},
@@ -332,15 +333,15 @@
 
 #define FIELDSTRUCT NeuroSignals
-{"add",0,PARAM_NOSTATIC,"add","p(s channel)",PROCEDURE(p_add),"Create a new signal"},
-{"receive",0,PARAM_NOSTATIC,"receive","p f(s channel)",PROCEDURE(p_receive),"Receive the aggregated signal power in a given channel."},
-{"receiveSet",0,PARAM_NOSTATIC,"receive","p oVector(s channel,f max distance)",PROCEDURE(p_receiveSet),"Get all signals in the specified range. Returns a readonly vector object containing Signal objects (individual signals can be accessed as result[0] throught result[result.size-1])."},
+{"add",0,PARAM_NOSTATIC,"Add","p(s channel)",PROCEDURE(p_add),"Create a new signal"},
+{"receive",0,PARAM_NOSTATIC,"Receive","p f(s channel)",PROCEDURE(p_receive),"Receive the aggregated signal power in a given channel."},
+{"receiveSet",0,PARAM_NOSTATIC,"Receive","p oVector(s channel,f max distance)",PROCEDURE(p_receiveSet),"Get all signals in the specified range. Returns a readonly vector object containing Signal objects (individual signals can be accessed as result[0] throught result[result.size-1])."},
 {"receiveFilter",0,PARAM_NOSTATIC,"receive","p f(s channel,f max distance,f flavor,f filter)",PROCEDURE(p_receiveFilter),"Receive the aggregated signal power in a given channel.\n\nAdditional filtering options:\n- Max distance only receives the neighbor signals (based on their physical location)\n- Flavor filtering: only signals having the flavor close to the specified one will be received. The filter value is the maximum allowed difference."},
-{"receiveSingle",0,PARAM_NOSTATIC,"receive","p oSignal(s channel,f range)",PROCEDURE(p_receiveSingle),"Find the signal source having the highest signal power (including the distance)"},
+{"receiveSingle",0,PARAM_NOSTATIC,"Receive","p oSignal(s channel,f range)",PROCEDURE(p_receiveSingle),"Find the signal source having the highest signal power (including the distance)"},
 #undef FIELDSTRUCT
 
 #define FIELDSTRUCT SignalSet
-{"get",0,PARAM_NOSTATIC,"get","p oSignal(d index)",PROCEDURE(p_get),},
-{"size",0,1+PARAM_NOSTATIC,"size","d",GETONLY(size),},
-{"clear",0,1+PARAM_NOSTATIC,"clear","p()",PROCEDURE(p_clear),},
+{"get",0,PARAM_NOSTATIC,"Get","p oSignal(d index)",PROCEDURE(p_get),},
+{"size",0,1+PARAM_NOSTATIC,"Size","d",GETONLY(size),},
+{"clear",0,1+PARAM_NOSTATIC,"Clear","p()",PROCEDURE(p_clear),},
 #undef FIELDSTRUCT
 {0,0,0,},
@@ -383,8 +384,12 @@
 void NeuroSignals::p_add(PARAMPROCARGS)
 {
-if (!owner->owner->channels) {ret->setEmpty();return;}
-SigChannel *ch=owner->owner->channels->getChannel(args->getString(),true);
 SigSource *s=new NeuroSigSource(owner,getCreature());
-ch->addSource(s);
+if (owner->owner->channels)
+	{
+	SigChannel *ch=owner->owner->channels->getChannel(args->getString(),true);
+	ch->addSource(s);
+	}
+else
+	SigChannel::dummy_channel.addSource(s);
 sigs+=s;
 s->setupObject(ret);
@@ -522,4 +527,9 @@
 }
 
+void NeuroImpl::get_classObject(ExtValue *ret)
+{
+NeuroClassExt::makeStaticObject(ret,neuroclass);
+}
+
 NeuroImpl::~NeuroImpl()
 {
